---
# Project configuration
project:
  name: gql-example
  laravel:
    version: 5.7.x
    dont_install: true

  environment: development
  
  # database:
  #   version: v4
---
# Generator configuration
remove-untracked: true

preprocessors:
  - web.graphql.bread
  - web.graphql
  - web.graphql.rebing
  - web.graphql.database
  - web.graphql.database.migration
  - web.graphql.authentication
  - web.graphql.authorization
  - web.database.eloquent

inputs:
  - ./blueprint/types.graphql
  - ?./blueprint/migrations/migration_*.json
  - ?./blueprint/custom.graphql
  - ./blueprint/authentication.yaml
  - ./blueprint/authorization.yaml
---
# Blueprint

# Create user defined graphql input file
/blueprint:
  custom.graphql: |
    @content
    # Add your custom graphql types, queries, mutations and extensions here

"install_laravel_framework": |  
    @unless "framework/artisan" is file
      @unless {project.laravel.dont_install}
        @shell
        echo "Initializing laravel {project.laravel.version} project..."
        composer create-project laravel/laravel:{project.laravel.version} framework
        cd framework
        composer require mattketmo/camel:1.1

/framework:

  /app:

    "{db_model.name|studly_caps}.php": >
      @foreach model in {database.models}
        @template php/laravel/model.php
          db_model: {model}

    /Policies:
      "{model.name|studly_caps}Policy.php": |
        @foreach p in {authorization.permission}
          @template php/laravel/policy.php
            graphql: {graphql}
            authorization: {authorization}
            permission: {p.value}
            ops: {p.value.operations}
            model: {p.value.model}

    /GraphQL:

      /Enum:
        "{enum.name|studly_caps}Enum.php": |
          @foreach enum in {graphql.enums}
            @template php/laravel/rebing-graphql/enum.php
              enum: {enum}

      /Input:
        "{type.name|studly_caps}Input.php": |
          @foreach input in {graphql.inputs}
            @template php/laravel/rebing-graphql/input.php
              type: {input}

      /Type:
        "{type.name|studly_caps}Type.php": |
          @foreach type in {graphql.types}
            @template php/laravel/rebing-graphql/type.php

      /Query:
        "{schema.name|studly_caps}Schema/{node.name|studly_caps}Query.php": |
          @foreach schema in {graphql.schema}
            @foreach query in {schema.query.fields}
              @template php/laravel/rebing-graphql/query.php
                node: {query}

      /Mutation:
        "{schema.name|studly_caps}Schema/{node.name|studly_caps}Mutation.php": |
          @foreach schema in {graphql.schema}
            @foreach mutation in {schema.mutation.fields}
              @template php/laravel/rebing-graphql/mutation.php
                node: {mutation}

      /Traits:
        QueryFilter.php: php/laravel/rebing-graphql/trait/query-filter.php

    # /Providers:
    #   AuthServiceProvider.php: php/laravel/providers/auth-service.php

  /config:
    graphql.php: php/laravel/rebing-graphql/config/graphql.php

  /database:
    /factories:
      # "{model.name|studly_caps}Factory.php": >
      #   @foreach model in {database.models}
      #     @template php/laravel/factory.php
      #       model: {model}

    /migrations:
      "{migration|migration_timestamp('%Y_%m_%d_%H%M%S')}{oper_index}_v{migration.version}_{oper.type}_{oper.tablename|snake_case}_table.php": |
        @foreach migration in {database.migrations}
          @foreach oper in {migration.operations}
            @template php/laravel/migration/{oper.type}.php

    #   "{datetime('%Y_%m_%d_%H%M')}{model_index}_create_{model.tablename|snake_case}_table.php": |
    #     @foreach model in {database.models}
    #       @template php/laravel/migration.php
    #         @cache-as create_{model.tablename|snake_case}_table.php
